CUDNN Frontend API 8.3.0

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType > Class Template Reference

`#include <json.hpp>`

Collaboration diagram for nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >:

## Public Types
using | number_integer_t = typename BasicJsonType::number_integer_t
using | number_unsigned_t = typename BasicJsonType::number_unsigned_t
using | number_float_t = typename BasicJsonType::number_float_t
using | string_t = typename BasicJsonType::string_t
using | binary_t = typename BasicJsonType::binary_t
using | parser_callback_t = typename BasicJsonType::parser_callback_t
using | parse_event_t = typename BasicJsonType::parse_event_t

## Public Member Functions
| json_sax_dom_callback_parser (BasicJsonType &r, const parser_callback_t cb, const bool allow_exceptions_=true)
| json_sax_dom_callback_parser (const json_sax_dom_callback_parser &)=delete
| json_sax_dom_callback_parser (json_sax_dom_callback_parser &&)=default
json_sax_dom_callback_parser & | operator= (const json_sax_dom_callback_parser &)=delete
json_sax_dom_callback_parser & | operator= (json_sax_dom_callback_parser &&)=default
| ~json_sax_dom_callback_parser ()=default
bool | null ()
bool | boolean (bool val)
bool | number_integer (number_integer_t val)
bool | number_unsigned (number_unsigned_t val)
bool | number_float (number_float_t val, const string_t &)
bool | string (string_t &val)
bool | binary (binary_t &val)
bool | start_object (std::size_t len)
bool | key (string_t &val)
bool | end_object ()
bool | start_array (std::size_t len)
bool | end_array ()
template<class Exception >
bool | parse_error (std::size_t, const std::string &, const Exception &ex)
constexpr bool | is_errored () const

## Private Member Functions
template<typename Value >
std::pair< bool, BasicJsonType * > | handle_value (Value &&v, const bool skip_callback=false)

## Private Attributes
BasicJsonType & | root
| the parsed JSON value More...
std::vector< BasicJsonType * > | ref_stack {}
| stack to model hierarchy of values More...
std::vector< bool > | keep_stack {}
| stack to manage which values to keep More...
std::vector< bool > | key_keep_stack {}
| stack to manage which object keys to keep More...
BasicJsonType * | object_element = nullptr
| helper to hold the reference for the next object element More...
bool | errored = false
| whether a syntax error occurred More...
const parser_callback_t | callback = nullptr
| callback function More...
const bool | allow_exceptions = true
| whether to throw exceptions in case of errors More...
BasicJsonType | discarded = BasicJsonType::value_t::discarded
| a discarded value for the callback More...

## Detailed Description

### template<typename BasicJsonType>
class nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >

Definition at line 6035 of file json.hpp.

## Member Typedef Documentation

## ◆ binary_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::binary_t = typename BasicJsonType::binary_t

Definition at line 6042 of file json.hpp.

## ◆ number_float_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_float_t = typename BasicJsonType::number_float_t

Definition at line 6040 of file json.hpp.

## ◆ number_integer_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_integer_t = typename BasicJsonType::number_integer_t

Definition at line 6038 of file json.hpp.

## ◆ number_unsigned_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_unsigned_t = typename BasicJsonType::number_unsigned_t

Definition at line 6039 of file json.hpp.

## ◆ parse_event_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::parse_event_t = typename BasicJsonType::parse_event_t

Definition at line 6044 of file json.hpp.

## ◆ parser_callback_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::parser_callback_t = typename BasicJsonType::parser_callback_t

Definition at line 6043 of file json.hpp.

## ◆ string_t

template<typename BasicJsonType>

using nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::string_t = typename BasicJsonType::string_t

Definition at line 6041 of file json.hpp.

## Constructor & Destructor Documentation

## ◆ json_sax_dom_callback_parser() [1/3]

template<typename BasicJsonType>

nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::json_sax_dom_callback_parser | ( | BasicJsonType & | r,
|  | const parser_callback_t | cb,
|  | const bool | allow_exceptions_ = `true`
| ) |  |
| inline

Definition at line 6046 of file json.hpp.

## ◆ json_sax_dom_callback_parser() [2/3]

template<typename BasicJsonType>

nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::json_sax_dom_callback_parser | ( | const json_sax_dom_callback_parser< BasicJsonType > & |  | ) |
| delete

## ◆ json_sax_dom_callback_parser() [3/3]

template<typename BasicJsonType>

nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::json_sax_dom_callback_parser | ( | json_sax_dom_callback_parser< BasicJsonType > && |  | ) |
| default

## ◆ ~json_sax_dom_callback_parser()

template<typename BasicJsonType>

nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::~json_sax_dom_callback_parser | ( |  | ) |
| default

## Member Function Documentation

## ◆ binary()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::binary | ( | binary_t & | val | ) |
| inline

Definition at line 6097 of file json.hpp.

## ◆ boolean()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::boolean | ( | bool | val | ) |
| inline

Definition at line 6067 of file json.hpp.

## ◆ end_array()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::end_array | ( |  | ) |
| inline

Definition at line 6191 of file json.hpp.

References nlohmann::detail::array_end, nlohmann::detail::discarded, and JSON_ASSERT.

## ◆ end_object()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::end_object | ( |  | ) |
| inline

Definition at line 6138 of file json.hpp.

References nlohmann::detail::discarded, JSON_ASSERT, and nlohmann::detail::object_end.

## ◆ handle_value()

template<typename BasicJsonType>
template<typename Value >

std::pair<bool, BasicJsonType*> nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::handle_value | ( | Value && | v,
|  | const bool | skip_callback = `false`
| ) |  |
| inlineprivate

Parameters

  [in] | v | value to add to the JSON value we build during parsing
  [in] | skip_callback | whether we should skip calling the callback function; this is required after start_array() and start_object() SAX events, because otherwise we would call the callback function with an empty array or object, respectively.

Invariant
  If the ref stack is empty, then the passed value will be the new root.
  If the ref stack contains a value, then it is an array or an object to which we can add elements

Returns
  pair of boolean (whether value should be kept) and pointer (to the passed value in the ref_stack hierarchy; nullptr if not kept)

Definition at line 6258 of file json.hpp.

References JSON_ASSERT, and nlohmann::detail::value.

## ◆ is_errored()

template<typename BasicJsonType>

constexpr bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::is_errored | ( |  | ) | const
| inline

Definition at line 6236 of file json.hpp.

Referenced by nlohmann::detail::parser< BasicJsonType, InputAdapterType >::parse().

## ◆ key()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::key | ( | string_t & | val | ) |
| inline

Definition at line 6121 of file json.hpp.

References nlohmann::detail::discarded, and nlohmann::detail::key.

## ◆ null()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::null | ( |  | ) |
| inline

Definition at line 6061 of file json.hpp.

## ◆ number_float()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_float | ( | number_float_t | val,
|  | const string_t & |
| ) |  |
| inline

Definition at line 6085 of file json.hpp.

## ◆ number_integer()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_integer | ( | number_integer_t | val | ) |
| inline

Definition at line 6073 of file json.hpp.

## ◆ number_unsigned()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::number_unsigned | ( | number_unsigned_t | val | ) |
| inline

Definition at line 6079 of file json.hpp.

## ◆ operator=() [1/2]

template<typename BasicJsonType>

json_sax_dom_callback_parser& nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::operator= | ( | const json_sax_dom_callback_parser< BasicJsonType > & |  | ) |
| delete

## ◆ operator=() [2/2]

template<typename BasicJsonType>

json_sax_dom_callback_parser& nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::operator= | ( | json_sax_dom_callback_parser< BasicJsonType > && |  | ) |
| default

## ◆ parse_error()

template<typename BasicJsonType>
template<class Exception >

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::parse_error | ( | std::size_t | ,
|  | const std::string & | ,
|  | const Exception & | ex
| ) |  |
| inline

Definition at line 6224 of file json.hpp.

References JSON_THROW.

Referenced by nlohmann::detail::parser< BasicJsonType, InputAdapterType >::parse().

## ◆ start_array()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::start_array | ( | std::size_t | len | ) |
| inline

Definition at line 6174 of file json.hpp.

References nlohmann::detail::array_start, nlohmann::detail::out_of_range::create(), nlohmann::detail::discarded, JSON_HEDLEY_UNLIKELY, JSON_THROW, and nlohmann::to_string().

## ◆ start_object()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::start_object | ( | std::size_t | len | ) |
| inline

Definition at line 6103 of file json.hpp.

References nlohmann::detail::out_of_range::create(), nlohmann::detail::discarded, JSON_HEDLEY_UNLIKELY, JSON_THROW, nlohmann::detail::object_start, and nlohmann::to_string().

## ◆ string()

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::string | ( | string_t & | val | ) |
| inline

Definition at line 6091 of file json.hpp.

## Member Data Documentation

## ◆ allow_exceptions

template<typename BasicJsonType>

const bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::allow_exceptions = true
| private

whether to throw exceptions in case of errors

Definition at line 6336 of file json.hpp.

## ◆ callback

template<typename BasicJsonType>

const parser_callback_t nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::callback = nullptr
| private

callback function

Definition at line 6334 of file json.hpp.

## ◆ discarded

template<typename BasicJsonType>

BasicJsonType nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::discarded = BasicJsonType::value_t::discarded
| private

a discarded value for the callback

Definition at line 6338 of file json.hpp.

## ◆ errored

template<typename BasicJsonType>

bool nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::errored = false
| private

whether a syntax error occurred

Definition at line 6332 of file json.hpp.

## ◆ keep_stack

template<typename BasicJsonType>

std::vector<bool> nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::keep_stack {}
| private

stack to manage which values to keep

Definition at line 6326 of file json.hpp.

## ◆ key_keep_stack

template<typename BasicJsonType>

std::vector<bool> nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::key_keep_stack {}
| private

stack to manage which object keys to keep

Definition at line 6328 of file json.hpp.

## ◆ object_element

template<typename BasicJsonType>

BasicJsonType* nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::object_element = nullptr
| private

helper to hold the reference for the next object element

Definition at line 6330 of file json.hpp.

## ◆ ref_stack

template<typename BasicJsonType>

std::vector<BasicJsonType*> nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::ref_stack {}
| private

stack to model hierarchy of values

Definition at line 6324 of file json.hpp.

## ◆ root

template<typename BasicJsonType>

BasicJsonType& nlohmann::detail::json_sax_dom_callback_parser< BasicJsonType >::root
| private

the parsed JSON value

Definition at line 6322 of file json.hpp.

The documentation for this class was generated from the following file:

- json.hpp